from Products.Archetypes.public import BaseFolderSchema, Schema
from Products.Archetypes.public import BaseFolder, registerType

from Products.CMFFolder.config import *

from Products.Archetypes.public import ImageField, StringField, TextField
from Products.Archetypes.public import ImageWidget, StringWidget, TextAreaWidget


from Products.CMFCore import CMFCorePermissions
from AccessControl import ClassSecurityInfo

from Products.CMFCore.utils import getToolByName

from AccessControl import getSecurityManager, SpecialUsers
from Acquisition import aq_base, aq_inner, aq_parent


from Products.CMFPlone.PloneFolder import ReplaceableWrapper

from Permissions import *
import string


#############################################################################
##                             Setting                                     ##
#############################################################################

schema = BaseFolderSchema +  Schema((
    ImageField('thumbnail',
              widget=ImageWidget(label="Thumbnail",
                         description='You can upload a 100x75 sized thumbnail for this CSS.'\
                                     ' The best and easiest to get thumbnail is resizing your screen dump!'),
              ),
    TextField('css_fields',
              default='<dtml-with base_properties>\n' \
                      'body{\n' \
                      '    background:&dtml-backgroundColor;;\n' \
                      '    color:black;\n' \
                      '}\n' \
                      '</dtml-with>\n',
              mutator='setCss_fields',
              widget=TextAreaWidget(label="Cascading Style Sheet",
                         description='Input your css code for this folder here'),
              ),
    ))


class CSS(BaseFolder):
    """
        Cascading Style Sheets
    """
    security = ClassSecurityInfo()
    
    schema = schema
    archetype_name = "CSS"
    
    #allowed_content_types=('DTMLMethod',)
    
    global_allow = 1
    
    
    filter_content_types = 1
    security = ClassSecurityInfo()

    
    actions = (
          { 'id': 'folderContents'
               ,'name': 'Contents'
               ,'action': 'string: ${folder_url}/folder_contents'
               ,'condition': 'python:member and folder is not object and object.displayContentsTab()'
               ,'permissions': (CMFCorePermissions.ListFolderContents,)
               , 'category'      : 'object'
               , 'visible'       : 0
          },
          )

    ##### Basic #####
    security.declareProtected(CMFCorePermissions.View, 'getIcon')
    def getIcon(self, relative_to_portal=0):
        return 'css_icon.gif'
    
    def manage_afterAdd(self, item, container):
        
        id = 'customstyle.css'
        if not hasattr(self, id):
            self.manage_addDTMLMethod(id, 'CSS for %s' % self.getId())
        
        method = getattr(self.aq_explicit, id)
        method.manage_edit(title='CSS', data=self.getCss_fields())
        
        BaseFolder.manage_afterAdd(self, item, container)
        
        
    

    ##### Accessors & Mutators #####
    security.declareProtected( SetQuota, 'setCss_fields' ) 
    def setCss_fields(self, value, **kwargs):
        schema = self.Schema()
        field = schema.get('css_fields', 0)
        field.set(instance=self, value=value)
        method = getattr(self.aq_explicit, 'customstyle.css')
        method.manage_edit(title='CSS', data=value)

    
    security.declareProtected( CMFCorePermissions.View, 'getCss' ) 
    def getCss(self):
        _target = aq_parent(aq_inner(self)).aq_acquire('customstyle.css')
        return ReplaceableWrapper(aq_base(_target).__of__(self))
        
    
    
    ### Checking functions ####
            
        
          


registerType(CSS)
